<?php

namespace MyMenu\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;

use MyMenu\Services\FCMService;

class FCMController {
    protected $FCMService;

    public function __construct( FCMService $FCMService ){
        $this->FCMService = $FCMService;
    }
    
    private function getHandledException( \Exception $error ) {
        $errorMsg = $error->getMessage();
        $isHandledError = stripos($errorMsg, "ERR_") === 0;
        if( $isHandledError ) {
            return $error;
        } else {
            return new \Exception("ERR_UNEXPECTED_EXCEPTION$$".$errorMsg);
        }
    }

    public function subscribeToTopic( Request\Row $request, Response $response ){
        try {
            $row = $request->getRow();
            $topic = $row['topic'] ?? null;
            $token = $row['token'] ?? null;

            $this->FCMService->subscribeToTopic($topic, $token);
        } catch ( \Exception $error ) {
            $errorMsg = $error->getMessage();
            $isHandledError = stripos($errorMsg, "ERR_") === 0;
            if( $isHandledError ) {
                throw $error;
            } else {
                throw new \Exception("ERR_UNEXPECTED_EXCEPTION$$".$errorMsg);
            }
        }
    }
    
    public function unsubscribeFromAllTopics( Request\Row $request, Response $response ) {
        try {
            $row = $request->getRow();
            $token = $row['token'] ?? null;
        } catch( \Exception $error ) {
            throw $this->getHandledException( $error );
        }
    }
}